<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="追溯类型" prop="traceType">
        <el-select v-model="queryParams.traceType" placeholder="请选择追溯类型" clearable size="small">
          <el-option
            v-for="dict in traceTypeOptions"
            :key="dict.dictValue"
            :label="dict.dictLabel"
            :value="dict.dictValue"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="企业" prop="beyondEnterpriseId">
        <el-select v-model="queryParams.beyondEnterpriseId" placeholder="请选择所属企业" clearable size="small">
          <el-option
            v-for = "dict in enterpriseList"
            :key = "dict.enterpriseId"
            :label = "dict.enterpriseName"
            :value = "dict.enterpriseId"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="气瓶码" prop="bottleCode">
        <el-input
          v-model="queryParams.bottleCode"
          placeholder="请输入气瓶码"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <!--<el-col :span="1.5">-->
        <!--<el-button-->
          <!--type="primary"-->
          <!--plain-->
          <!--icon="el-icon-plus"-->
          <!--size="mini"-->
          <!--@click="handleAdd"-->
          <!--v-hasPermi="['lpgRegulation:traceback:add']"-->
        <!--&gt;新增</el-button>-->
      <!--</el-col>-->
      <!--<el-col :span="1.5">-->
        <!--<el-button-->
          <!--type="success"-->
          <!--plain-->
          <!--icon="el-icon-edit"-->
          <!--size="mini"-->
          <!--:disabled="single"-->
          <!--@click="handleUpdate"-->
          <!--v-hasPermi="['lpgRegulation:traceback:edit']"-->
        <!--&gt;修改</el-button>-->
      <!--</el-col>-->
      <!--<el-col :span="1.5">-->
        <!--<el-button-->
          <!--type="danger"-->
          <!--plain-->
          <!--icon="el-icon-delete"-->
          <!--size="mini"-->
          <!--:disabled="multiple"-->
          <!--@click="handleDelete"-->
          <!--v-hasPermi="['lpgRegulation:traceback:remove']"-->
        <!--&gt;删除</el-button>-->
      <!--</el-col>-->
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
		  :loading="exportLoading"
          @click="handleExport"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="tracebackList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="气瓶码" align="center" prop="bottleCode" />
      <el-table-column label="追溯类型" align="center" prop="traceType" :formatter="traceTypeFormat" />
      <el-table-column label="企业" align="center" prop="enterpriseName" />
      <el-table-column label="储备站" align="center" prop="stationName" />
      <el-table-column label="操作人" align="center" prop="people" />
      <el-table-column label="操作时间" align="center" prop="createTime" />
      <el-table-column label="备注" align="center" prop="remark" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleDetail(scope.row)"
          >详情</el-button>
          <!--<el-button-->
            <!--size="mini"-->
            <!--type="text"-->
            <!--icon="el-icon-delete"-->
            <!--@click="handleDelete(scope.row)"-->
          <!--&gt;删除</el-button>-->
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改气瓶追溯对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="追溯类型" prop="traceType">
          <el-select v-model="form.traceType" placeholder="请选择追溯类型">
            <el-option
              v-for="dict in traceTypeOptions"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="工序关联主键" prop="relationId">
          <el-input v-model="form.relationId" placeholder="请输入工序关联主键" />
        </el-form-item>
        <el-form-item label="企业id" prop="beyondEnterpriseId">
          <el-input v-model="form.beyondEnterpriseId" placeholder="请输入企业id" />
        </el-form-item>
        <el-form-item label="储备站" prop="stationName">
          <el-input v-model="form.stationName" placeholder="请输入储备站" />
        </el-form-item>
        <el-form-item label="气瓶码" prop="bottleCode">
          <el-input v-model="form.bottleCode" placeholder="请输入气瓶码" />
        </el-form-item>
        <el-form-item label="操作人" prop="people">
          <el-input v-model="form.people" placeholder="请输入操作人" />
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

    <el-dialog :title="title" :visible.sync="open2" width="600px" append-to-body>
      <el-form ref="form" :model="form"  label-width="80px">
        <el-form-item label="操作类型" prop="traceType">
            气瓶{{traceTypeFormat(form,null)}}
        </el-form-item>
        <el-form-item label="企业名称" prop="beyondEnterpriseId">
         {{form.enterpriseName}}
        </el-form-item>

        <el-form-item label="气瓶编码" prop="bottleCode">
          {{form.bottleCode}}
        </el-form-item>
        <el-form-item label="操作人" prop="people">
          {{form.people}}
        </el-form-item>
        <el-form-item label="操作时间" prop="people">
          {{form.createTime}}
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          {{form.remark}}
        </el-form-item>
      </el-form>
    </el-dialog>


    <DetailInfo ref="detail"/>
    <DeliiveryDetailInfo ref="detail2"/>
    <CheckDetailInfo ref="detail4"/>
  </div>
</template>

<script>
import { listTraceback, getTraceback, delTraceback, addTraceback, updateTraceback, exportTraceback } from "@/api/lpgRegulation/traceback";
import {enterpriseList } from "@/api/system/planInfo";
import DetailInfo from "../airchargefiles/components/indexInfo";
import DeliiveryDetailInfo from "../deliveryrecord//components/DetailInfo";
import CheckDetailInfo from "../check/components/DetailInfo";
export default {
  name: "Traceback",
  components: {
    DetailInfo,DeliiveryDetailInfo,CheckDetailInfo
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 气瓶追溯表格数据
      tracebackList: [],
      enterpriseList:[],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      open2: false,
      // 追溯类型字典
      traceTypeOptions: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        traceType: null,
        beyondEnterpriseId: null,
        bottleCode: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getList();
    this.getEnterpriseList()
    this.getDicts("t_trace_type").then(response => {
      this.traceTypeOptions = response.data;
    });
  },
  methods: {
    //公司列表
    getEnterpriseList() {
      enterpriseList({pageNum: 1,
        pageSize: 100}).then(response => {
        this.enterpriseList = response.data;
    });
    },
    /** 查询气瓶追溯列表 */
    getList() {
      this.loading = true;
      listTraceback(this.queryParams).then(response => {
        this.tracebackList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 追溯类型字典翻译
    traceTypeFormat(row, column) {
      return this.selectDictLabel(this.traceTypeOptions, row.traceType);
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.open2 = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        traceId: null,
        traceType: null,
        relationId: null,
        beyondEnterpriseId: null,
        stationName: null,
        bottleCode: null,
        people: null,
        createTime: null,
        remark: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.traceId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加气瓶追溯";
    },

    //详情
    handleDetail(row){
      if(row.traceType=='1'){
        this.$refs.detail.getDetailInfo(row.relationId);
      }else if(row.traceType=='2'){
        this.$refs.detail2.getDetailInfo(row.relationId);
      }else  if(row.traceType=='4'){
        this.$refs.detail4.getDetailInfo(row.relationId);
      }else{
        getTraceback(row.traceId).then(response => {
          this.form = response.data;
          this.open2 = true;
          this.title = "详情";
        });
      }

    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const traceId = row.traceId || this.ids
      getTraceback(traceId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改气瓶追溯";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.traceId != null) {
            updateTraceback(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addTraceback(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const traceIds = row.traceId || this.ids;
      this.$confirm('是否确认删除气瓶追溯编号为"' + traceIds + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delTraceback(traceIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有气瓶追溯数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportTraceback(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>
